/* This is my (Ed Mandy) PVoice library.

   I used GBDK v 2.1.5 to compile the object file, but I have also included
   the .s file so you can edit it.  If you do edit it, please tell me so I
   can add the new functionality to the library.

   Oh, and all I ask is that you give me credit if you use this in any
   of your creations.  If you do use it, I'd really like to hear about it,
   but in any case, please just give me credit in your program.

   Thanks,
   Ed Mandy
   emandy@atcorp.com
   ICQ:  17868116
*/

/*  Call this before recording/playing.
    */
void initPVoice();


/*  playVoice will play numBytes of data from the buffer that sound points
    to.
*/
UWORD playVoice(const void *sound, UWORD numBytes);

/*  recVoice will record numBytes of data to the buffer that sound points
    to.
    If you release the A button, recVoice will stop recording.
    I would recommend asking the user to press-and-hold the A button
    until they are done recording.  Call recVoice once they have pressed
    the A button, and recVoice will return either when the A button has
    been released or when numBytes have been recorded (whichever comes
    first).
*/
UWORD recVoice(const void *sound, UWORD numBytes);

/*   PVoiceROMcpy     (in theory)
     This is supposed to copy to (or from) PocketVoice ROM.

     Here's what Bung says about it.
		;; If you want to write data to Pocket Voice's Flash Rom, it needs to
		;; copy some routines includes the writing Flash Rom main routine to
		;; GB's work Ram 0xc000--0xdfff and jump to run it. It is because during
		;; flashing, the whole Flash Rom can't be read as normal, some times it
		;; just be read and checked in it's d7 or d6 only for waiting last page
		;; written ready. So some routines need to be run in GB's work ram area.

     You may want to do something like this before using it, so that you
     can reference the function from RAM.
     UWORD (*PVROMcpy)() = (UWORD (*)())0xD500;
     // Copy 'PVoiceROMcpy' to RAM at 0xD500
     memcpy((void *)0xD500, (void *)&start_PVoiceROMcpy, (UWORD)(&end_PVoiceROMcpy-&start_PVoiceROMcpy));
     //reference it from RAM
     PVROMcpy((void *)(0x6010), &sound[0], soundSize);  //flash sound to ROM

     returns numBytes

     As far as I know, this doesn't work at all, though it's as close to
     Bung's documentation and ASM code.  If anybody can fix it, please feel
     free to, and I will update mine to look like yours (with your name, even).
     Oh, and the following function prototype may not be correct.  I think it
     is, but I haven't touched this code for a while.  I just included it
     here so people could read through my comments and see that it doesn't
     work, anyway.  :)
*/
UWORD PVoiceROMcpy(const void *to, const void *from, UWORD numBytes);
